// python wrapper for vtkXdmf3HeavyDataHandler
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkXdmf3HeavyDataHandler.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkXdmf3HeavyDataHandler(PyObject *dict); }
static PyMethodDef PyvtkXdmf3HeavyDataHandler_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_s1(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkXdmf3HeavyDataHandler");

  PyObject *result = nullptr;

  if (ap.CheckArgCount(0))
  {
    vtkXdmf3HeavyDataHandler *op = new vtkXdmf3HeavyDataHandler();

    result = PyVTKSpecialObject_New("vtkXdmf3HeavyDataHandler", op);
  }

  return result;
}

static PyObject *
PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_s2(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkXdmf3HeavyDataHandler");

  vtkXdmf3HeavyDataHandler *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkXdmf3HeavyDataHandler"))
  {
    vtkXdmf3HeavyDataHandler *op = new vtkXdmf3HeavyDataHandler(*temp0);

    result = PyVTKSpecialObject_New("vtkXdmf3HeavyDataHandler", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_Methods[] = {
  {"vtkXdmf3HeavyDataHandler", PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_s2, METH_VARARGS,
   "@W vtkXdmf3HeavyDataHandler"},
  {nullptr, nullptr, 0, nullptr}
};

static PyObject *
PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler(PyObject *self, PyObject *args)
{
  int nargs = vtkPythonArgs::GetArgCount(args);

  switch(nargs)
  {
    case 0:
      return PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_s1(self, args);
    case 1:
      return PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_s2(self, args);
  }

  vtkPythonArgs::ArgCountError(nargs, "vtkXdmf3HeavyDataHandler");
  return nullptr;
}


static const char *PyvtkXdmf3HeavyDataHandler_Doc =

  "vtkXdmf3HeavyDataHandler() -> vtkXdmf3HeavyDataHandler\nC++: vtkXdmf3HeavyDataHandler()\nvtkXdmf3HeavyDataHandler(__a:vtkXdmf3HeavyDataHandler)\n    -> vtkXdmf3HeavyDataHandler\nC++: vtkXdmf3HeavyDataHandler(const &vtkXdmf3HeavyDataHandler)\n""\n"
  "vtkXdmf3HeavyDataHandler - internal helper for vtkXdmf3Reader\n\n"
  "vtkXdmf3Reader uses this class to read the heavy data from the XDMF\n"
  "file(s).\n\n"
  "This file is a helper for the vtkXdmf3Reader and not intended to be\n"
  "part of VTK public API\n\n";

static PyObject *
PyvtkXdmf3HeavyDataHandler_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler(nullptr, args);
}

static void PyvtkXdmf3HeavyDataHandler_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkXdmf3HeavyDataHandler *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkXdmf3HeavyDataHandler_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkXdmf3HeavyDataHandler_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkIOXdmf3.vtkXdmf3HeavyDataHandler", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkXdmf3HeavyDataHandler_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkXdmf3HeavyDataHandler_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkXdmf3HeavyDataHandler_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkXdmf3HeavyDataHandler_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkXdmf3HeavyDataHandler_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkXdmf3HeavyDataHandler(*static_cast<const vtkXdmf3HeavyDataHandler*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkXdmf3HeavyDataHandler_TypeNew
extern "C" { PyObject *PyvtkXdmf3HeavyDataHandler_TypeNew(); }
#define DECLARED_PyvtkXdmf3HeavyDataHandler_TypeNew
#endif

PyObject *PyvtkXdmf3HeavyDataHandler_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkXdmf3HeavyDataHandler_Type,
    PyvtkXdmf3HeavyDataHandler_Methods,
    PyvtkXdmf3HeavyDataHandler_vtkXdmf3HeavyDataHandler_Methods,
    &PyvtkXdmf3HeavyDataHandler_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkXdmf3HeavyDataHandler(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkXdmf3HeavyDataHandler_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkXdmf3HeavyDataHandler", o) != 0)
  {
    Py_DECREF(o);
  }

}

