// python wrapper for vtkXdmf3LightDataHandler
//
#define VTK_WRAPPING_CXX
#define VTK_STREAMS_FWD_ONLY
#include "vtkPythonArgs.h"
#include "vtkPythonOverload.h"
#include <cstddef>
#include <sstream>
#include "vtkVariant.h"
#include "vtkXdmf3LightDataHandler.h"

#if defined(PYTHON_PACKAGE)
#define PYTHON_PACKAGE_SCOPE PYTHON_PACKAGE "."
#else
#define PYTHON_PACKAGE_SCOPE
#endif

extern "C" { VTK_ABI_EXPORT void PyVTKAddFile_vtkXdmf3LightDataHandler(PyObject *dict); }
static PyMethodDef PyvtkXdmf3LightDataHandler_Methods[] = {
  {nullptr, nullptr, 0, nullptr}
};


static PyObject *
PyvtkXdmf3LightDataHandler_vtkXdmf3LightDataHandler(PyObject * /*unused*/, PyObject *args)
{
  vtkPythonArgs ap(args, "vtkXdmf3LightDataHandler");

  vtkXdmf3LightDataHandler *temp0 = nullptr;
  PyObject *pobj0 = nullptr;
  PyObject *result = nullptr;

  if (ap.CheckArgCount(1) &&
      ap.GetSpecialObject(temp0, pobj0, "vtkXdmf3LightDataHandler"))
  {
    vtkXdmf3LightDataHandler *op = new vtkXdmf3LightDataHandler(*temp0);

    result = PyVTKSpecialObject_New("vtkXdmf3LightDataHandler", op);
  }

  Py_XDECREF(pobj0);

  return result;
}

static PyMethodDef PyvtkXdmf3LightDataHandler_vtkXdmf3LightDataHandler_Methods[] = {
  {"vtkXdmf3LightDataHandler", PyvtkXdmf3LightDataHandler_vtkXdmf3LightDataHandler, METH_VARARGS,
   "@W vtkXdmf3LightDataHandler"},
  {nullptr, nullptr, 0, nullptr}
};


static const char *PyvtkXdmf3LightDataHandler_Doc =

  "vtkXdmf3LightDataHandler(__a:vtkXdmf3LightDataHandler)\n    -> vtkXdmf3LightDataHandler\nC++: vtkXdmf3LightDataHandler(const &vtkXdmf3LightDataHandler)\n""\n"
  "vtkXdmf3LightDataHandler - internal helper for vtkXdmf3Reader\n\n"
  "vtkXdmf3Reader uses this class to inspect the light data in the XDMF\n"
  "file(s) and determine meta-information about the vtkDataObjects it\n"
  "needs to produce.\n\n"
  "This file is a helper for the vtkXdmf3Reader and not intended to be\n"
  "part of VTK public API\n\n";

static PyObject *
PyvtkXdmf3LightDataHandler_New(PyTypeObject *, PyObject *args, PyObject *kwds)
{
  if (kwds && PyDict_Size(kwds))
  {
    PyErr_SetString(PyExc_TypeError,
                    "this function takes no keyword arguments");
    return nullptr;
  }

  return PyvtkXdmf3LightDataHandler_vtkXdmf3LightDataHandler(nullptr, args);
}

static void PyvtkXdmf3LightDataHandler_Delete(PyObject *self)
{
  PyVTKSpecialObject *obj = (PyVTKSpecialObject *)self;
  delete static_cast<vtkXdmf3LightDataHandler *>(obj->vtk_ptr);
  PyObject_Del(self);
}

static Py_hash_t PyvtkXdmf3LightDataHandler_Hash(PyObject *self)
{
  return PyObject_HashNotImplemented(self);
}

#ifdef VTK_PYTHON_NEEDS_DEPRECATION_WARNING_SUPPRESSION
#pragma GCC diagnostic ignored "-Wdeprecated-declarations"
#endif

static PyTypeObject PyvtkXdmf3LightDataHandler_Type = {
  PyVarObject_HEAD_INIT(&PyType_Type, 0)
  PYTHON_PACKAGE_SCOPE "vtkIOXdmf3.vtkXdmf3LightDataHandler", // tp_name
  sizeof(PyVTKSpecialObject), // tp_basicsize
  0, // tp_itemsize
  PyvtkXdmf3LightDataHandler_Delete, // tp_dealloc
#if PY_VERSION_HEX >= 0x03080000
  0, // tp_vectorcall_offset
#else
  nullptr, // tp_print
#endif
  nullptr, // tp_getattr
  nullptr, // tp_setattr
  nullptr, // tp_compare
  PyVTKSpecialObject_Repr, // tp_repr
  nullptr, // tp_as_number
  nullptr, // tp_as_sequence
  nullptr, // tp_as_mapping
  PyvtkXdmf3LightDataHandler_Hash, // tp_hash
  nullptr, // tp_call
  nullptr, // tp_str
  PyObject_GenericGetAttr, // tp_getattro
  nullptr, // tp_setattro
  nullptr, // tp_as_buffer
  Py_TPFLAGS_DEFAULT, // tp_flags
  PyvtkXdmf3LightDataHandler_Doc, // tp_doc
  nullptr, // tp_traverse
  nullptr, // tp_clear
  nullptr, // tp_richcompare
  0, // tp_weaklistoffset
  nullptr, // tp_iter
  nullptr, // tp_iternext
  nullptr, // tp_methods
  nullptr, // tp_members
  nullptr, // tp_getset
  nullptr, // tp_base
  nullptr, // tp_dict
  nullptr, // tp_descr_get
  nullptr, // tp_descr_set
  0, // tp_dictoffset
  nullptr, // tp_init
  nullptr, // tp_alloc
  PyvtkXdmf3LightDataHandler_New, // tp_new
  PyObject_Del, // tp_free
  nullptr, // tp_is_gc
  nullptr, // tp_bases
  nullptr, // tp_mro
  nullptr, // tp_cache
  nullptr, // tp_subclasses
  nullptr, // tp_weaklist
  VTK_WRAP_PYTHON_SUPPRESS_UNINITIALIZED
};

static void *PyvtkXdmf3LightDataHandler_CCopy(const void *obj)
{
  if (obj)
  {
    return new vtkXdmf3LightDataHandler(*static_cast<const vtkXdmf3LightDataHandler*>(obj));
  }
  return nullptr;
}

#ifndef DECLARED_PyvtkXdmf3LightDataHandler_TypeNew
extern "C" { PyObject *PyvtkXdmf3LightDataHandler_TypeNew(); }
#define DECLARED_PyvtkXdmf3LightDataHandler_TypeNew
#endif

PyObject *PyvtkXdmf3LightDataHandler_TypeNew()
{
  PyTypeObject *pytype = PyVTKSpecialType_Add(
    &PyvtkXdmf3LightDataHandler_Type,
    PyvtkXdmf3LightDataHandler_Methods,
    PyvtkXdmf3LightDataHandler_vtkXdmf3LightDataHandler_Methods,
    &PyvtkXdmf3LightDataHandler_CCopy);

  if ((PyType_GetFlags(pytype) & Py_TPFLAGS_READY) != 0)
  {
    return (PyObject *)pytype;
  }

  PyType_Ready(pytype);
  return (PyObject *)pytype;
}

void PyVTKAddFile_vtkXdmf3LightDataHandler(
  PyObject *dict)
{
  PyObject *o;
  o = PyvtkXdmf3LightDataHandler_TypeNew();

  if (o && PyDict_SetItemString(dict, "vtkXdmf3LightDataHandler", o) != 0)
  {
    Py_DECREF(o);
  }

}

